/*
==========================================================================
    ElectroDacus Solar BMS "SBMS60" menu file.

    Copyright (C) 2014  <Dacian Todea>
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
===========================================================================
*/


static char* const mainmenu[][2] =
{
		{"        Monitoring           ","> Battery monitor and graphs "},
		{"     Parameter Settings      ","> Battery parameter settings "},
		{"       Device Settings       ","> Device settings and other non battery type settings "},
		{"  Automation (EXT IO & ADC)  ","> External IO and ADC settings              "},
		{"         Diagnostic          ","> Diagnostic this is just experimental for development"},
		{"       Manual & Install      ","> Manual and step by step installation instruction."},
		{"            About            "," http://www.electrodacus.com "},
		{"                             ","-----"}

};

static char* const devset[][2] =
{
		{"          Time & Date        ","> Time and date settings"},
		{"        LCD & TouchKey       ","> LCD brightness and TouchKey lock settings "},
		{"            USART            ","> USART settings - if you use USART the WiFi will be deactivated since they both use the same USART port"},
		{"             WiFi            ","> WiFi  settings - you can not use the USART port while using WiFi "},
		{"       Internal-datalog      ","> Internal SPI FLASH data log settings "},
		{"o    Save device setting    o","> Will save all device settings plus EXT IO and ADC settings to internal non volatile memory so after next power cycle this will be used as default"},
		{"o      Factory reset!       o","> It will reset all device settings to default but a power cycle is needed to make this happen. Make sure PV and Load is disconnected before power cycle"},

};

static char* const extioadcset[][2] =
{
		{"          EXT IOx            ","> The 4 external IO pins available on the 20 pin connector can be used to control external devices"},
		{"    ADC (ExtLoad setting)    ","> Setting the ExternalLoad on/off and the current shunt value plus manual calibration for all internal current measurement"},
};

static char* const manualset[][2] =
{
		{"    Install instructions     ","> Step by step installation instructions for the Solar BMS"},
		{"   Manual & Specifications   ","> Basic manual and specifications for the Solar BMS"},
};


static char* const timedate[][3] =
{
		{"Hour                ","> Set Hour ","h  "},
		{"Minutes             ","> Set minutes ","m  "},
		{"Day                 ","> Set day ","   "},
		{"Month               ","> Set month ","   "},
		{"Year                ","> Set year  ","   "},

};

static char* const LCDbacklight[][3] =
{
		{"Back light level    ","> Set Back-light level from 1 to 32 ","   "},
		{"Menu color          ","> Change menu color profile to one of the predefined color maps","   "},
		{"Back light time out ","> Set Back-light time on in minutes (after this time will elapse from the last key press the backlight level will be reduced to level 5 ) ","m  "},
		{"Key lock time out   ","> Set Capacitive Touch Key's lock time in minutes ","m  "},
};

static char* const EXT125[][3] =
{
		{"EXTIO 3 Type        ","> EXTIO3 (0=OFF) (1=HVD High Voltage Disconnect) (2=LVD Low Voltage Disconnect) (3=Set if EXT3>=SOC) (4=Set if EXT3<=SOC) (5=Set in case of over or under voltage lock).","   "},
		{"EXTIO 3 SOC         ","> EXTIO3 SOC % level. Active if EXTIO 3 Type is set as 3 or 4.  ","%  "},
		{"EXTIO 4 Type        ","> EXTIO4 (0=OFF) (1=HVD High Voltage Disconnect) (2=LVD Low Voltage Disconnect) (3=Set if EXT4>=SOC) (4=Set if EXT4<=SOC) (5=Set in case of over or under voltage lock).","   "},
		{"EXTIO 4 SOC         ","> EXTIO4 SOC % level. Active if EXTIO 4 Type is set as 3 or 4.  ","%  "},
		{"EXTIO 5 Type        ","> EXTIO5 (0=OFF) (1=HVD High Voltage Disconnect) (2=LVD Low Voltage Disconnect) (3=Set if EXT5>=SOC) (4=Set if EXT5<=SOC) (5=Set in case of over or under voltage lock).","   "},
		{"EXTIO 5 SOC         ","> EXTIO5 SOC % level. Active if EXTIO 5 Type is set as 3 or 4.  ","%  "},
		{"EXTIO 6 Type        ","> EXTIO6 (0=OFF) (1=HVD High Voltage Disconnect) (2=LVD Low Voltage Disconnect) (3=Set if EXT6>=SOC) (4=Set if EXT6<=SOC) (5=Set in case of over or under voltage lock).","   "},
		{"EXTIO 6 SOC         ","> EXTIO6 SOC % level. Active if EXTIO 6 Type is set as 3 or 4.  ","%  "}
};

static char* const ADC[][3] =
{
		{"ExtLoad On / Off   ","> ExtLoad (0=OFF) (1=ON) leave off if you do not use an external shunt to measure an external load. Up to 500A current shunt can be used","    "},
		{"ExtLoad shunt      ","> Set the value of the external current shunt in mOhm example for a 500A 75mV shunt you do 75mV / 500A = 0.1500mOhm ","mOhm"},
		{"ExtLoad offset     ","> ExtLoad manual offset in case offset is negative and can not be auto calibrated ( related to current shunt amplifier )","mA  "},
		{"PV1 shunt          ","> Set the value of the PV1 internal current shunt in mOhm in order to compensate for all components tolerances and get a more accurate reading ","mOhm"},
		{"PV1 offset         ","> PV1 manual offset in case offset is negative and can not be auto calibrated (is related to current shunt amplifier ) ","mA  "},
		{"PV2 shunt          ","> Set the value of the PV2 internal current shunt in mOhm in order to compensate for all components tolerances and get a more accurate reading ","mOhm"},
		{"PV2 offset         ","> PV2 manual offset in case offset is negative and can not be auto calibrated (is related to current shunt amplifier ) ","mA  "},
		{"Battery shunt      ","> Set the value of the internal current shunt in mOhm in order to compensate for all components tolerances and get a more accurate reading","mOhm"},
};


static char* const counterreset[][2] =
{
		{" NONE  ","> No reset on any counter  "},
		{"  PV2  ","> Reset the PV2 counter "},
		{"  PV1  ","> Reset the PV1 counter "},
		{"PV1+PV2","> Reset both the PV1 and PV2 counter "},
		{"Battery","> Reset the Battery counter "},
		{" Load  ","> Reset the Load counter "},
		{"ExtLoad","> Reset the ExtLoad counter "},
		{"  ALL  ","> Reset all counters "},

};

static char* const graphzoom1[][2] =
{
		{"Current","> Graph for current. All values are in Amp"},
		{" Power ","> Graph for power. All values are in Watt "},
		{"PV1+PV2","> Zoom the PV1+PV2 graph "},
		{"Battery","> Zoom the Battery graph "},
		{" Load  ","> Zoom the Load graph "},
};

static char* const graphzoom1h[][2] =
{
		{"Current","> Graph for current. All values are in Amp"},
		{" Power ","> Graph for power. All values are in Watt "},
		{"4minute","> Display the last 4 minute graph "},
		{"4hours ","> Display the last 4 hour graph "},
		{"24hours","> Display the last 24 hour graph "},
};

static char* const loadonoffm1[][2] =
{
		{"LoadON ","> Load and PV charging ON "},
		{"LoadOFF","> Load and PV charging OFF "}
};


static unsigned int const timedateval[5][5] =
{
		{2,0,0,23,1},     //1
		{2,0,0,59,1},     //2
		{2,0,1,31,1},     //4
		{2,0,1,12,1},     //4
		{4,0,2016,2116,1},//5
};



static unsigned int const realcurrent[8][4] =
{
		{0,12  ,3   ,48 },        //1  ID,Discharge,Charge,ShortCircuit SBMS100
		{1,24  ,6   ,72 },       //2
		{2,48  ,12  ,96 },       //3
		{3,72  ,18  ,144},       //4
		{4,72  ,24  ,192},       //5
		{5,72  ,36  ,288},       //6
		{6,72  ,48  ,384},       //7
		{7,72  ,72  ,384},       //8
};


static unsigned int const backlightval[4][5] =
{
		{2,0,1,32,1},     //0 0
		{1,0,0,9,1},      //3 1
		{2,0,0,59,1},     //1 2
		{2,0,0,59,1},     //2 3

};

static unsigned int const EXT125val[8][5] =
{
		{1,0,0,5,1},     //
		{2,0,1,99,1},     //
		{1,0,0,5,1},     //
		{2,0,1,99,1},     //
		{1,0,0,5,1},     //
		{2,0,1,99,1},     //
		{1,0,0,5,1},     //
		{2,0,1,99,1},     //

};

static unsigned int const ADCval[8][5] =
{
		{1,0,0,1,1},            // EXTADC1 on/off
		{5,4,1400,99999,1},     // EXTADC1 shunt value mohm
		{3,0,0,500,1},          // EXTADC1 offset mV
		{5,4,3200,3500,1},      // PV1 shunt value mohm
		{3,0,0,300,1},          // PV1 offset mV
		{5,4,3200,3500,1},      // PV2 shunt value mohm
		{3,0,0,300,1},          // PV2 offset mV
		{5,4,3200,3500,1},      // Batt+ shunt value mohm  SBMS60
};



static char* const USARTmenu[][3] =
{
		{"USART Data Log      ","> USART Data Logging enable or disable ","   "},
		{"Baud rate           ","> Set USART Baud rate default 9600 ","K  "},
		{"Log interval        ","> Set the data logging time interval ","s  "}
};

static unsigned int const USARTval[4][5] =
{
		{1,0,0,1,1},       //1
		{4,1,96,9999,1},   //2  serial baud rate up to 1Mbps
		{3,0,1,240,1},     //3  4 minute max
};

static char* const WiFimenu[][3] =
{
		{"WiFi On(1) / Off(0) ","> WiFi enable or disable ","   "},
		{"WiFi AP Channel     ","> WiFi fixed channel selection ","Ch "},
		{"AP name        SBMS-","> WiFi Access Point name SBMS-xxx ","   "},
		{"Pass On(1) / Off(0) ","> Set password for AP if you want not really necessary ","   "},
		{"AP Pass  part1      ","> First part of the AP password xxxxx ","   "},
		{"AP Pass  part2      ","> Second part of the password xxxxxBMS full password is xxxxxxxxxxBMS ","BMS"}
};

static unsigned int const WiFival[7][5] =
{
		{1,0,0,1,1},     //1
		{2,0,1,14,1},    //2
		{3,0,0,999,1},   //3
		{1,0,0,1,1},     //4
		{5,0,0,99999,1}, //5
		{5,0,0,99999,1}, //6
};

static char* const uSDmenu[][3] =
{
		{"Select month        ","> Select the month you want to download ","   "},
		{"o    Start data download    o","> Start downloading one month worth of data over WiFi ",""},
};

static unsigned int const uSDval[7][5] =
{
		{2,0,1,12,1},      //1

};





static unsigned int const cellsetup[6][8] =
{
		{1,0,0,0,0,0,1,1},     //3cell
		{1,1,0,0,0,0,1,1},     //4cell
		{1,1,0,0,0,1,1,1},     //5cell
		{1,1,1,0,0,1,1,1},     //6cell
		{1,1,1,0,1,1,1,1},     //7cell
		{1,1,1,1,1,1,1,1}      //8cell
};



static char* const EFT[15][2]=
{
{"   OV   ","Over Voltage "},//0
{"  OVLK  ","Over V Lock  "},//1
{"   UV   ","Under Voltage"},//2
{"  UVLK  ","Under V Lock "},//3
{"   IOT  ","Int over Temp"},//4
{"   COC  ","C OverCurrent"},//5
{"   DOC  ","D OverCurrent"},//6
{"   DSC  ","Short circuit"},//7
{"  CELF  ","Cell fail    "},//8
{"  OPEN  ","Open Cell    "},//9
{"   LVC  ","Low Voltage C"},//10
{"  ECCF  ","EEPROM fail  "},//11
{"  CFET  ","Charge FET   "},//12
{"   EOC  ","End of Charge"},//13
{"  DFET  ","Discharge FET"}//14
};



static char* const extconnector1[20]=
{
"    USART TX",
"USART RX    ",
"SDA/ EXT IO1",
"EXT IO2 /SCL",
"      BOOT 0",
"EXT IO5 /SWK",
"   ESP FLASH",
"EXT IO6 /SWD",
"         GND",
"GND         ",
"USBN/EXT IO3",
"XT1 EXT Temp",
"USBP/EXT IO4",
"3.3V-100ohm ",
"       ADC1N",
"ADC1P       ",
"    EXT ADC2",
"EXT ADC3    ",
"    EXT ADC4",
"GND         "
};



static unsigned int const BatteryType [34][8] =
{
		{1,2,3,4,5,6},                      //1
		{8,7,6,8,8,8},                      //2
		{200,200,100,27,27,27},             //3
		{355,400,260,230,250,270},          //4
		{1,1,1,1,1,1},                      //5
		{340,380,255,210,230,250},          //6
		{280,320,190,100,100,100},          //7
		{1,1,1,1,1,1},                      //8
		{320,360,230,120,120,120},          //9
		{375,420,270,235,255,275},          //10
		{250,290,160,80,80,80},             //11
		{353,398,258,227,247,267},          //12
		{230,260,150,80,80,80},             //13
		{72,72,72,24,24,24},                //14 SBMS60
		{250,250,250,250,250,250},          //15
		{72,72,72,24,24,24},                //16 SBMS60
		{160,160,160,160,160,160},          //17
		{288,288,288,48,48,48},             //18 SBMS60
		{600,600,600,400,400,400},          //19
		{0,0,0,0,0,0},                      //20
		{1,1,1,1,1,1},                      //21
		{320,350,230,110,110,110},          //22
		{355,400,260,230,250,270},          //23
		{10,10,10,10,10,10},                //24
		{350,500,300,900,900,900},          //25
		{6,6,6,4,4,4},                      //26
		{2,2,1,1,1,1},                      //27
		{719,719,719,719,719,719},          //28
		{4096,4096,4096,4096,4096,4096},    //29
		{0,0,0,0,0,0},                      //30
		{230,230,140,75,75,75},             //31
		{15,15,15,15,15,15},                //32
		{15,15,15,15,15,15},                //33
		{240,240,240,240,240,240}           //34

};



static char* const bmsmenu[][3] =
{
		{"Cell Type           ",">Predefined battery type most will probably want to use type 1 for LiFePO4","   "},
		{"Number of Cells     ",">Number of series connected cells see below diagram on how to connect the cells. For 3cell(1,2,8) 4cell(1,2,7,8) 5cell(1,2,3,7,8) 6cell(1,2,3,6,7,8) 7cell(1,2,3,4,6,7,8)","   "},
		{"Battery Capacity    ",">Capacity of the battery bank in Ah or supercapacitor/ultracapacitor bank in Farad","HH"},
		{"Over Voltage        ",">Overvoltage Threshold *If any cell voltage is above this for an overvoltage delay time the charge FET is turned OFF.","V  "},
		{"Over Voltage Delay  ",">Overvoltage Delay Time Out *Sets the time that is required for any cell to be above the overvoltage threshold before condition is detected.","s  "},
		{"Over Voltage Recov  ",">Overvoltage Recovery *If all cells fall below this the charge FET is turned ON.","V  "},
		{"Under Voltage       ",">Undervoltage Threshold *If any cell voltage is below this for an undervoltage delay time the discharge FET is turned OFF.","V  "},
		{"Under Voltage Delay ",">Undervoltage Delay Time Out *Sets the time that is required for any cell to be below the undervoltage threshold before condition is detected.","s  "},
		{"Under Voltage Recov ",">Undervoltage Recovery *If all cells rise above this (and there is no load) the discharge FET is turned ON.","V  "},
		{"Over Voltage Lock   ",">Overvoltage Lock-out Threshold *If any cell is above this the charge FET is turned OFF the cell balance FET's are turned OFF and OVLO bit is set.","V  "},
		{"Under Voltage Lock  ",">Undervoltage Lock-out Threshold *If any cell is below this the discharge FET is turned OFF and the UVLO bit is set.","V  "},
		{"End of Charge       ",">End-of-Charge Threshold *If any cell exceeds this the EOC bit is set.","V  "},
		{"Low Voltage Chg     ",">Low Voltage Charge Level *If the voltage on any cell is below this then battery charge will not be allowed and manual slow cell charge will be required","V  "},
		{"Over Current Chg    ",">Charge Overcurrent Threshold *If current is above this for the time set at ICdelay.","A  "},
		{"Chg Current Delay   ",">Charge Overcurrent Time Out *A charge overcurrent condition needs to remain for this time period prior to entering a charge overcurrent condition.","s  "},
		{"Over Current Dsg    ",">Discharge Overcurent Threshold *If current is above this for the time set at IDdelay.","A  "},
		{"Dsg Current Delay   ",">Discharge Overcurent Time Out *A discharge overcurent condition needs to remain for this time period to entering a discharge overcurrent condition.","s  "},
		{"ShortCircuitCurrent ",">Discharge Short Circuit Threshold.","A  "},
		{"ShortCircuit Delay  ",">Discharge Short Circuit Time Out A short circuit current needs to remain for this time prior entering a short circuit condition.","us "},
		{"Cell Balance on Dsg ",">If this is 1 = ON if 0 = OFF.","   "},
		{"Cell Balance on Chg ",">If this is 1 = ON if 0 = OFF.","   "},
		{"Cell Balance min    ",">Cell balance minimum.","V  "},
		{"Cell Balance max    ",">Cell balance maximum.","V  "},
		{"Cell Balance min dV ",">Cell balance min delta.","mV "},
		{"Cell Balance max dV ",">Cell balance max delta.","mV "},
		{"Cell Balance ON     ",">Cell balance ON time.","s  "},
		{"Cell Balance OFF    ",">Cell balance OFF time.","s  "},
		{"Internal ISL Over T ",">Internal over temperature according to spec 730mV==115C and 690mV==95C so this is the default setting do not change leave 719mV","mV "},
		{"Min Ext Temperature ",">External under temperature recommended to use 3000b=5C if you use 10k ext thermistor but better cool the thermistor and check the value in Diagnostic page","b  "},
		{"Max Ext Temperature ",">External over temperature recommended max 1040b=60C or 1338b=50C if you use 10k ext thermistor but better heat thermistor and check value in Diagnostic page","b  "},
		{"Sleep Voltage       ",">Sleep Voltage where ISL94203 will enter in sleep mode after the time mentioned below at sleep voltage delay","V  "},
		{"Sleep Voltage Delay ",">If any cell voltage is below sleep voltage set above for a delay set here the ISL94203 will enter sleep mode.","s  "},
		{"Doze/Idle Delay     ",">The ISL94203 will enter Idle and then Doze mode after a delay set here if no charge or discharge current is detected min ~600mA SBMS100 and ~450mA SBMS60.","m  "},
		{"Sleep Delay         ",">The ISL94203 will enter sleep mode after Idle/Doze delay has elapsed and then enter sleep mode after the delay set here. Max time is 15m+15+240m=270m ","m  "},
		{"o     Store Parameters      o",">Store all parameters to main IC. It will need a (reset) disconnect and reconnect to battery for the changes to take effect.",""},
		{" Advanced Parameter Settings ",">Advanced parameter settings only for advanced users that understand different battery characteristics.",">>"},
		{" "," "," "},
		{'\0','\0','\0'}

};

static unsigned int const bmsmenuval[36][5] =
{
		{1,0,1,6,1},     //1
		{1,0,3,8,1},     //2
		{4,0,1,9999,1},  //3
		{3,2,80,480,1},  //4
		{1,0,0,9,1},     //5
		{3,2,80,480,1},  //6
		{3,2,80,480,1},  //7
		{1,0,0,9,1},     //8
		{3,2,80,480,1},  //9
		{3,2,80,480,1},  //10
		{3,2,80,480,1},  //11
		{3,2,80,480,1},  //12
		{3,2,80,480,1},  //13
		{3,0,0,7,1},     //14
		{3,0,0,999,1},   //15
		{3,0,0,3,1},     //16
		{3,0,0,999,1},   //17
		{3,0,0,6,1},     //18
		{3,0,0,999,1},   //19
		{1,0,0,1,1},     //20
		{1,0,0,1,1},     //21
		{3,2,80,480,1},  //22
		{3,2,80,480,1},  //23
		{4,0,0,4800,1},  //24
		{4,0,0,4800,1},  //25
		{1,0,0,9,1},     //26
		{1,0,0,9,1},     //27
		{3,0,690,730,1}, //28
		{4,0,0,4096,1},  //29
		{4,0,0,4096,1},  //30
		{3,2,80,480,1},  //31
		{2,0,0,31,1},   //32
		{2,0,0,15,1},    //33
		{3,0,0,240,16},   //34
};

static uint16_t const bmscolor[10][64] =
{
		{32,2113,2113,4193,4226,6306,6338,8386,8419,10499,10531,12612,12612,14692,14725,16805,16837,18885,18918,20998,21030,23111,23111,25191,25224,27304,27336,29384,29417,31497,31529,33610,33610,35690,35723,37803,37835,39883,39916,41996,42028,44109,44109,46189,46222,48302,48334,50382,50415,52495,52527,52560,54608,54640,56721,56753,58833,58833,60914,60946,63026,63059,65107,65535,},    //0
		{32,2112,2112,4193,4225,6305,6337,8385,8417,10498,10530,12610,12610,14690,14722,16802,16835,18883,18915,20995,21027,23107,23107,25188,25220,27300,27332,29380,29412,31493,31525,33605,33605,35685,35717,37797,37830,39878,39910,41990,42022,44102,44102,46183,46215,48295,48327,50375,50407,52488,52520,52552,54600,54632,56712,56744,58825,58825,60905,60937,63017,63049,65097,65535,},     //1
        {32,2112,2113,4193,4225,6305,6305,8386,8418,10498,10498,12578,12611,14691,14691,16771,16803,18884,18884,20964,20996,23076,23077,25157,25189,27269,27269,29350,29382,31462,31462,33542,33575,35655,35655,37735,37767,39848,39848,41928,41960,44040,44041,46121,46153,48233,48233,50314,50346,52426,52426,52458,54539,54571,56619,56651,58731,58764,60812,60844,62924,62956,65005,65535},  //2
        {32,2112,2145,2177,4257,4289,4321,4354,6434,6466,6498,8578,8611,8643,10723,10755,10787,10820,12900,12932,12964,15044,15077,15109,17189,17221,17253,17286,19366,19398,19430,21510,21543,21575,23655,23687,23719,23752,25832,25864,25896,27976,28009,28041,30121,30153,30185,30218,32298,32330,32362,34442,34475,34507,36587,36619,36651,36684,38764,38796,38828,40908,40941,65535,},  //3
		{32,64,96,128,2209,2241,2273,2305,2337,2369,2401,2433,2465,2497,4578,4610,4642,4674,4706,4738,4770,4802,4834,4866,6947,6979,7011,7043,7075,7107,7139,7171,7203,7235,9316,9348,9380,9412,9444,9476,9508,9540,9572,9604,11685,11717,11749,11781,11813,11845,11877,11909,11941,11973,14054,14086,14118,14150,14182,14214,14246,14278,14310,65535,},  //6  Green 1, Red 0.1, Blue 0.1  4
        {32,2080,2080,4160,4161,6209,6241,8289,8321,10369,10369,12449,12450,14530,14530,16578,16610,18658,18690,20738,20739,22819,22819,24899,24899,26947,26979,29027,29059,31108,31108,33188,33188,35268,35268,37316,37348,39397,39429,41477,41477,43557,43557,45637,45637,47686,47718,49766,49798,51846,51846,51878,53926,53958,56007,56007,58087,58087,60167,60167,62215,62247,64296,65535,},   //5
		{0,2048,2080,4128,4128,6176,6176,8256,8256,10305,10305,12353,12385,14433,14433,16481,16481,18561,18561,20609,20609,22657,22689,24737,24737,26785,26785,28865,28865,30914,30914,32962,32994,35042,35042,37090,37090,39170,39170,41218,41218,43266,43298,45346,45346,47394,47394,49474,49474,51523,51523,51523,53603,53603,55651,55651,57699,57731,59779,59779,61827,61827,63907,65535},   //6
		{32,2081,2113,4161,4194,6274,6274,8355,8355,10436,10468,12516,12549,14597,14629,16710,16710,18790,18791,20871,20903,22952,22984,25032,25065,27145,27145,29226,29226,31307,31339,33387,33420,35468,35500,37581,37581,39661,39662,41742,41774,43823,43855,45903,45936,48016,48016,50097,50097,52178,52210,52210,54291,54291,56371,56404,58452,58484,60533,60565,62645,62646,64726,65535,},  //7
		{0,33,33,66,66,67,99,100,132,2181,2181,2214,2214,2247,2247,2248,2280,2281,2313,2314,2314,2347,2347,2380,2380,2381,2413,2414,2446,4495,4495,4528,4528,4561,4561,4562,4594,4595,4627,4628,4628,4661,4661,4694,4694,4695,4727,4728,4760,6809,6809,6841,6842,6874,6875,6875,6908,6908,6941,6941,6942,6974,6975,65535},//8
        {32,65,97,130,2210,2211,2243,2276,2308,2341,2373,2406,2438,2471,4551,4552,4584,4617,4649,4682,4714,4747,4779,4812,6892,6893,6925,6958,6990,7023,7055,7088,7120,7153,9233,9234,9266,9299,9331,9364,9396,9429,9461,9494,11574,11575,11607,11640,11672,11705,11737,11769,11802,11834,13915,13915,13948,13980,14013,14045,14078,14110,14143,65535}//9



};
static uint16_t const wirecolor[10] =
		{18885,65535,37835,54106,30,14150,58825,0xFBE0,0xF800,58087};



static char* const install1[][2] =
{
		{" Step 0                      ","                                             \n                                             \n                                             \n                                             \n                                             \n                                             \n                                             \n                                             \n"},
		{" Step 1                      ","Connect the Batt+ power connector to battery \npositive terminal with a max 2m (6ft) of     \n16mm2 (#6AWG) flexible copper wire with 200C \nsilicone insulation (check manual for more   \ndetails about the recommended cable).        \nMake sure this is the first connected and    \nlast to be removed.                          \n                                             \n"},
		{" Step 2                      ","Connect the 10pin cell monitor and balancing \ncable.                                       \nMake sure this is the second one to be       \nconnected after Batt+ and never disconnect   \nwhile anything else is connected except for  \nthe Batt+.                                   \nSee details in manual or Parameter Settings  \non how this is connected to individual cells.\n"},
		{" Step 3                      ","Go to Parameter Settings menu and select the \ntype of cell, number of cells and battery    \ncapacity then push Store Parameters button to\nsave data to SBMS.                           \nThen remove the 10pin connector and reconnect\nfor the new stored parameters to be accepted.\n                                             \n                                             \n"},
		{" Step 4                      ","Go to Monitoring menu page 3 and push the OK \nbutton then a small sub menu will be         \ndisplayed in the top left corner. Use down   \nkey to select Load OFF and then push OK to   \nenable this. You should see CFET and DFET    \nflags change state from highlighted to not   \nbeing highlighted meaning that Load+,PV1+ and\nPV2+ are disconnected internally.            \n"},
		{" Step 5                      ","Connect Load+ using the same type of cable   \nmentioned in Step1 to a 125A circuit breaker \nin OFF position and from there to your Load. \n                                             \n                                             \n                                             \n                                             \n                                             \n"},
		{" Step 6                      ","Connect the PV1 and or PV2 to your PV array  \nto appropriate size circuit breaker in OFF   \nposition.                                    \nSee the manual for the type of PV panels     \nrecommended based on the number of cells and \nbattery voltage.                             \n                                             \n                                             \n"},
		{" Step 7                      ","Switch the Load and PV breakers in ON        \nposition and then go again to page 3 of the  \nMonitoring Menu and select Load ON this time.\nThe CFET and DFET should be highlighted and  \nthe Load should now have power also the PV1  \nand PV2 should provide charging current.     \n                                             \n                                             \n"},
		{" Step 8                      ","Check the first page of the Monitoring Menu  \nto see if all works correctly.               \nYou are done.                                \nMake sure you follow the install procedure in\nreverse when you want to remove the SBMS.    \nMake sure you never remove the Batt+ or 10pin\ncell monitoring connector while PV1, PV2 or  \nLoad+ is connected.                          \n"},
		{'\0','\0'}

};


static char* const manual1[][2] =
{
		{" Step 0                      ","                                             \n                                             \n                                             \n                                             \n                                             \n                                             \n                                             \n                                             \n                                             "},
		{" Table of Contents           ","Specifications.............................02\nThermal management.........................05\nCable selection............................10\nExternal Load..............................13\nExternal Temperature.......................17\n                                             \n                                             \n                                             \n                                             "},
		{" Specifications 1            ","[A] Battery type:                            \nany rechargeable Lithium or Supercapacitors. \n[B] Number of cells:  3 to 8                 \n[C] Battery voltage limits: min(8V) max(32V).\n[D] Battery / PV recommendation for 12V:     \n4 cells LiFePO4 / 32 or 36 cells PV panels.  \n[E] Battery / PV recommendation for 24V:     \n8 cell LiFePO4 or 7 cell LiCoO2 / 60 or 72   \ncells PV panels.                             "},
		{" Specifications 2            ","[F] Max PV open circuit voltage: 47V         \n[G] Cell balancing current: max 200mA        \n[H] Power terminal max wire size 35mm2/#2AWG \n[I] Weight: ~255gram                         \n[J] Size: 100mm x 90mm x 26mm                \n[K] Self consumption: 250mW to 700mW         \n[L] Max TDP*: SBMS100 (22W) SBMS60 (14W)     \n*SBMS needs to be mounted on and external    \nheatsink.                                    "},
		{" Specifications 3            ","[M] Max PV array STC power (STC current):    \nSBMS60 1800W(60A) / SBMS100 3000W(100A)      \n[N] Load+ overcurrent limit:                 \nSBMS60 72A / SBMS100 120A                    \n[O] PV1 or PV2 max current:                  \nSBMS60 72A / SBMS100 72A                     \n[P] PV1 + PV2 max current:                   \nSBMS60 72A  / SBMS100 120A                   \n                                             "},
		{" Thermal management 1        ","For detailed install procedure please see    \nInstall Instructions.                        \nThe SBMS60 and SBMS100 will need to be       \nmounted on an appropriate size heatsink able \nto dissipate the max TDP (Total Dissipated   \nPower) that is as high as 22W for SBMS100 and\n14W for the SBMS60 at full load (charge and  \ndischarge at the same time).                 \n                                             "},
		{" Thermal management 2        ","If size and weight is of great concern a fan \ncan be used to cool the back of the SBMS.    \nIf SBMS is not used with full configuration  \nthen a smaller heatsink can be used or even  \nno heatsik at all.                           \nYou can use the simple formula below to      \ncalculate the TDP.                           \nTDP[W]=I[A]*I[A]*R[ohm]                      \nSee two example of TDP on next page.         "},
		{" Thermal management 3        ","Before the example you need to know the R    \nfor Load+ and PV1/PV2                        \nLoad+ resistance path on SBMS100 is 1mOhm and\nSBMS60 is 1.5mohm where PVx input on SBMS100 \nis 2.4mohm and on SBMS60 is 3mohm.           \nSo for max configuration on SBMS100 you have \non Load+ TDP= 100A*100A*0.001ohm=10W         \non PV1 TDP= 50A*50A*0.0024ohm=6W PV2 also 6W \nSo total 10W+6W+6W = 22W on full load SBMS100"},
		{" Thermal management 4        ","The SBMS100 without any heatsink or fan can  \nat most dissipate 4W to 5W so below is an    \nexample with lower power to allow this.      \nSBMS100 with max 40A load and 24A on each PV \nLoad+ TDP=40A*40A*0.001ohm=1.6W              \nand PVx TDP=24A*24A*0.0024ohm=1.38W          \ntotal 1.6W+1.38W+1.38W=4.36W                 \nSo 40A load and 48A charging is around max   \nsupported by SBMS100 without heatsink.       "},
		{" Thermal management 5        ","The SBMS has an internal 10k thermistor      \ninstalled on the power board and will measure\nand display the temperature of that board.   \nIf temperature exceeds +60C the charging and \ndischarging will be turned off and only      \nturn on the charging and discharging when    \ntempearure drops below 50C.                  \n                                             \n                                             "},
		{" Cable selection 1           ","SBMS requires flexible copper cables.        \nFor full load configuration I recommend using\nhigh quality 16mm2(sold as #6AWG) flexible   \ntinned copper cable with 3200 0.08mm strands \nand 200 degrees Celsius silicone isolation.  \nI measured 1.125mohm/m for this cable and    \nyou will want to keep the resistance of cable\nbetwen battery positive terminal and SBMS    \nBatt+ connector below 2.5mohm so around 2m   "},
		{" Cable selection 2           ","max is recommended for this particular cable.\nNo fuse or breaker is allowed between Batt+  \nand battery positive terminal.               \nUse the same cable between Load+ and a DC    \ncircuit breaker.                             \nThe same cable can be also used betwen PVx   \nand a DC circuit breaker.                    \nThe circuit breakers on PVx and Load+ will   \nallow for a way to manually disconnect the   "},
		{" Cable selection 3           ","circuit and offer redundant overcurrent      \nprotection.                                  \nWhen you connect the cable to the SBMS power \nconnectors please do not use to much torque. \nSince you will probably using a 4mm hex allen\nkey the force pushing on the cable will be   \nmultiplied 628 times even with a 10cm long   \nkey.                                         \nExcessive force can break the connectors.    "},
		{" External Load 1             ","On both SBMS60 and SBMS100 an External Load  \ncan be connected allowing large loads of up  \nto 500A to be connected.                     \nAll is needed for this is a 75mV current     \nshunt can be 10A up to 500A and the load     \nneeds to support remote ON/OFF.              \n(Optoisolation may be required).             \nThe current sense output from the current    \nshunt gets connected on pins 15 and 16 on the"},
		{" External Load 2             ","20pin connector.                             \nThe pin16 (ADC1P) will be on the Battery     \npositive side of the current shunt resistor  \nand pin15 (ADC1N) on the side going to your  \nexternal load presumably a DC to AC power    \ninvrter.                                     \nThe external load will need to support remote\nON/OFF capabilities and that will be         \nconnected to one of the 4 EXT IO pins.       "},
		{" External Load 3             ","The EXT IO pin you decide to use for this    \nwill need to be programmed in the EXT IOx    \nsubmenu as type 2 (Low Voltage Disconnect)   \nor as type 4 if you want the Load (inverter) \nto be disconnected when battery gets below   \na certain SOC level (user programmable).     \nAnother setting you will need to do is in the\nADC (ExtLoad settings) submenu where you will\nbe turning the ExtLoad ON and providing the  "},
		{" External Load 4             ","ExtLoad shunt resistance value in [mohm]     \nThere is a simple formula to calculate the   \ncurrent shunt resistance value.              \nAs example a 500A 75mV shunt will have a     \nresistance value of 75mV/500A=0.1500mohm     \nanother example for a 75mV/200A=0.3750mohm   \nand last example for a 75mV/10A=7.500mohm    \n                                             \n                                             "},
		{" External Temperature 1      ","It is possible to add an external temperature\nsensor but is optional and in most cases not \nneeded.                                      \nAll Lithium batteries require temperatures   \nabove freezing (> +5C) during charging else  \nthey will get damaged.                       \nBest way when possible is to have the battery\ninside the living space where temperature    \nis ideal for battery operation.              "},
		{" External Temperature 2      ","The SBMS is designed to accept a thermistor  \nas temperature sensor connected between      \npin 12 and one of the GND pins like pin 10 on\nthe 20 pins connector.                       \nThe SBMS is calibrated for a particular 10K  \nthermistor made by Murata NCP21XV103J03RA    \nThis same thermistor is used internally to   \nmeasure the power board temperature.         \n                                             "},
		{" External Temperature 3      ","The low and high temperature limits for this \nexternal temperature sensor can be set from  \nthe Advanced Parameter Setting submenu       \nparameter 29 and 30.                         \nValue is a 12bit binary nr and if you use    \nthe recommended thermistor the 0C=3144b,     \n+5C=3000b, +50C=1338b, +55C=1182b, +60C=1040b\nYou can see the actual temp in Monitoring    \nmenu and the raw binary in Diagnostic menu.  "},
		{'\0','\0'}

};
